using System;
using System.Collections.Generic;
using System.Text;

using MySql.Data.MySqlClient;

namespace MYSQL_Connector_But_Test_Case
{
    //Requires the bug.sql script to have been run to create the table.
     
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Connecting to Mysql DB");

            String connectionString = "Server=10.0.0.52;Database=test;Uid=test;Pwd=test;";
            Console.WriteLine("Bug Evident");
            testBug(connectionString, "SELECT imageSize, image FROM artwork a WHERE id = ?id");
            
            Console.WriteLine("\nNormal Behaviour");
            testBug(connectionString, "SELECT image,imageSize FROM artwork a WHERE id = ?id");


            Console.WriteLine("\nPress any key to exit");
            Console.ReadKey();
        }

        static private void testBug(String connectionString, String query)
        {
            uint artworkID = 1;
            byte[] returnData;
            uint imageSize;

            //Create the connection to the db server
            MySqlConnection connection  = new MySqlConnection(connectionString);
            connection.Open();

            //Create the db command
            MySqlCommand command = connection.CreateCommand();

            //Create the query
            command.CommandText = query;
            command.Prepare();
            command.Parameters.Add("?id", artworkID);

            MySqlDataReader reader = command.ExecuteReader();

            long returnedLength = 0;

            //Read the image data from the database
            if (reader.Read())
            {
                imageSize = reader.GetUInt32(reader.GetOrdinal("imageSize"));
                returnData = new byte[imageSize];

                //This is the line where the bug appears
                returnedLength = reader.GetBytes(reader.GetOrdinal("image"), 0, returnData, 0, (int)(imageSize));
            }
            else
            {
                returnData = new byte[0];
            }

            Console.WriteLine("Data length returned " + returnedLength);

            reader.Close();

            connection.Close();
        }

    }
}
